Page MenuHome

Laggy interaction with gizmos, does not happen when running other 3D apps at the same time
Closed, ResolvedPublic

Description

System Information
Operating system: Win 10
Graphics card: GTX 1050 Ti

Blender Version
Broken:
2.80, 036ec5cae4f7, blender2.8, 2019-02-11

Short description of error

Open clean build today
Enable the "Move" tool in the "T" panel -> select cube -> keys 1,3,7 on the numpad, or drag with shift the viewport(short period) - lag

When running "only" Blender. There are no apps in the background.
no messengers, no browser, no photoshop. no applications using GPU.
We get lags.
As soon as we launch Telegram or Unity or ... (GPU using) everything becomes fine.
Only on Windows

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
Sebastian Parborg (zeddb) raised the priority of this task from Needs Information from User to Normal.

can you try with an empty object? to see if it really comes from the tranform gizmo? also you can change your active tool to the cursor tool to verify that.

yes, when transform gizmo active - lag. scale/move/spin etc

HI, I have the same problem when gizmo is active.
Windows 10
Nvidia gtx 1060 Ti

same problem Gtx 1070
I think It is the same as T57677

it looks like card detection or acceleration problem since it exists only if nothing is using a card in the background, even opening the Nvidia experience just speeds stuff.

edit:
it is related to all gizmos not only transform, even python ones

Same here, downloaded the feb10 nightly build and the feb14 build as well, I can confirm I'm having this exact issue, anytime the gizmo is present in the view port, it slows down view port performance and creates stutters and lag. Running a quick cycles preview render once on viewport seems to help alleviate the stuttering, but it is still there.

***Edit: viewport panning/rotating stutter and lag seems to be present when a camera object is selected as well, without the transform gizmo active, though the active "click and drag" handle function of changing the camera focal length should be taken into consideration as well for this bug.

@Clément Foucault (fclem) This weird lag behavior is last about month for now, don't it should be high priority and fixed since it is totally ruin usability?
This lug still in all latest builds and I can reproduce it on different machines.
Please, don't throw such bugs that makes blender unusable at all.

I wouldn't call it completely unusable, but it is peculiar that the gizmo tool works perfect on current 2.79 but has so much lag on 2.8. Its such a nice dynamic tool to use, I hope the bug can be fixed soon.

Clément Foucault (fclem) renamed this task from Move tool on - lag to Tranformation Gizmo is slowing down the viewport.Mar 23 2019, 11:48 PM

Can anyone try to reproduce the issue with tomorrow's built (March 24th) using --debug-gpu as command line argument? This should disable Polygon and line smoothing on the gizmos. I want to know if that's the issue or something else.

Can anyone try to reproduce the issue with tomorrow's built (March 24th) using --debug-gpu as command line argument? This should disable Polygon and line smoothing on the gizmos. I want to know if that's the issue or something else.

Hi @Clément Foucault (fclem).

I tried to launch blender with --debug-gpu. For me it made things worse - with gizmo changing view became super laggy, even pie menus won't open properly.

Yes, also.
with the --debug-gpu option, fps drops to ~ 1-2f/s
and Yes smoothing is disabled.
tried on two PC
win 10 x64 1050ti
win 7 x64 gtx960

 2.80 Beta Windows 64 bit
March 25, 01:08:27 - 07f6be87a97e

This is strange. I'm not sure what other state could provoke this slowdown. @Campbell Barton (campbellbarton) any idea?

@Clément Foucault (fclem) Sorry to interrupt, but I'd like to know if the bug's priority will be raised to high, to fix for release 2.80? Thanks!

with the edc1b0167518 build and the --debug-gpu argument, everything is also slow down and even stronger.
But when you run blender_debug_gpu.cmd, which is located in the folder with the build. and actively gizmo - works almost without lags.
logs will attach.

Did the situation improved with todays build?

@Clément Foucault (fclem)
With 2.80 Beta Windows 64 bit May 09, 10:41:16 - 209c01a6ba64

still also...

Oleg (DotBow) added a comment.EditedMay 9 2019, 1:00 PM

Did the situation improved with todays build?

I tested almost every build from 3 may til today- everything works perfect.

Operating system: Windows-10-10.0.17763 64 Bits
Graphics card: GeForce GTX 1050 Ti/PCIe/SSE2 NVIDIA Corporation 4.5.0 NVIDIA 418.91

Same here, tested nearly every build since the code quest last year. No problem with the transformation gizmo. Maybe a driver problem?
Operating system: Windows-10 Pro 64bit
Graphics card: GeForce GTX 1080 Ti/PCIe/SSE2 NVIDIA Corporation 4.5.0 NVIDIA 419.35

@Eugene (cgeugene) Just to make sure:

  • Do you have SLI or any multi gpu configuration?
  • Did you change any parameter concerning blender in nvidia application control panel? Check if anything override application parameters.
  • Could you try reinstalling your driver after doing a clean wipe using Display Driver Uninstaller?

the problem is still there even with today's build

I think that saying its related to gizmo is super misleading.
It is way more noticeable when gizmos are present but it's still there without it

I mentioned that before on topic that was merged here, the problem is there only if other software ( even in the background) is not using the video card
Opening anything next to blender instance will give an instant speedup that includes Nvidia Experience Overlay which is enabled on GTX cards by default, so 99% of users will not even notice unless they disable everything.

This comment was removed by Oleg (DotBow).
Eugene (cgeugene) added a comment.EditedMay 9 2019, 2:43 PM

@Clément Foucault (fclem)

I tried on different PCs
win 7 x64 gtx 960
win 10 x64 gtx 1050 ti
win 10 x64 rtx 2080
with drivers 418.91 and 419.35.
I even tried to install a new OS on a clean ssd.

  • No SLI or other configuration.
  • In the nvidia application control panel there are no changes.
  • I even tried to install a new OS on a clean ssd.

When running "only" Blender. There are no apps in the background.
no messengers, no browser, no photoshop. no applications using GPU.

We get lags.
As soon as we launch Telegram or Unity or ... (GPU using) everything becomes fine.
This wrote @Adrian Rutkowski (rrtk) in his T57677

the problem is still there even with today's build
I think that saying its related to gizmo is super misleading.
It is way more noticeable when gizmos are present but it's still there without it
I mentioned that before on topic that was merged here, the problem is there only if other software ( even in the background) is not using the video card
Opening anything next to blender instance will give an instant speedup that includes Nvidia Experience Overlay which is enabled on GTX cards by default, so 99% of users will not even notice unless they disable everything.

Yes, exactly! Most people don't notice because they run lots of garbage in the background which prevents GPU from idling. Only in rare cases do people care about their system background processes remaining clean and not utilizing much of hardware resources. And only then this bug manifests. For some reason, in some cases, which include gizmos being visible, Blender keeps getting the GPU to idle, which causes constant lag spikes and stutter. I have to solve this by always launching OBS and keeping it running in the background, so that it keeps the GPU awake.

In Blender 2.79, this bug was present too, but it was possible to fix it by forcing High Performance profile for Blender.exe:


In 2.8 however, this fix unfortunately no longer works...

the problem is still there even with today's build
I think that saying its related to gizmo is super misleading.
It is way more noticeable when gizmos are present but it's still there without it
I mentioned that before on topic that was merged here, the problem is there only if other software ( even in the background) is not using the video card
Opening anything next to blender instance will give an instant speedup that includes Nvidia Experience Overlay which is enabled on GTX cards by default, so 99% of users will not even notice unless they disable everything.

Yes, exactly! Most people don't notice because they run lots of garbage in the background which prevents GPU from idling. Only in rare cases do people care about their system background processes remaining clean and not utilizing much of hardware resources. And only then this bug manifests. For some reason, in some cases, which include gizmos being visible, Blender keeps getting the GPU to idle, which causes constant lag spikes and stutter. I have to solve this by always launching OBS and keeping it running in the background, so that it keeps the GPU awake.

That's super weird, but you are right! When only blender running - super laggy. As soon as I start Unreal Engine 4 - everything starting to work fine.

I think this is related to T60043 to some extent. Can someone try to change the app setting in nvidia control panel to Performance Mode or something like that? Looks like the driver don't know that we are actually rendering and miss some frames.

Edit: Sorry just saw it does not work in 2.8

Alternatively is playback in blender fluid (test with settings set to 60fps)?

I´m using the Prefer Maximum Performance Option in the Nvidia Controll Panel ever since.
It is recommended in other 3D applications, we are working with in our company.
Maybe therefore I never experienced any performance lag?!

This comment was removed by Eugene (cgeugene).

works fine, almost always at 60 fps
but sags to red values

Alternatively is playback in blender fluid (test with settings set to 60fps)?

I didn't quite understand what we should see?

i too have the same issue even with the default scene ,and if i disable just the transform gizmos in the popover it goes back to normal speed...one note though the same for Active tools gizmos however if you hide them with the popover option the issue still there and u can select them even if they are hidden, probably that's another bug.

my Specs :
Windows 10 64bits
GTX 1050 Ti latest Driver
Blender 2.80.60 today's build.

Can anyone test running GPU-Z while

  1. start blender
  2. validate it's slow
  3. start unity or whatever else that 'makes it fast'
  4. validate it is fast now
  5. Take a screenshot of the sensors tab

Laggy (only blender running):


Smooth (OBS just running in the background - not recording):

Same problem

System Information
Operating system: Windows-10-10.0.17763 64 Bits
Graphics card: GeForce GTX 970/PCIe/SSE2 NVIDIA Corporation 4.5.0 NVIDIA 430.86

Blender Version
Broken: version: 2.80 (sub 74), branch: blender2.7, commit date: 2019-06-04 22:32, hash: rBe80cbdac331a

Brecht Van Lommel (brecht) renamed this task from Tranformation Gizmo is slowing down the viewport to Laggy interaction with gizmos, does not happen when running other 3D apps at the same time.Jun 6 2019, 4:08 PM
Brecht Van Lommel (brecht) raised the priority of this task from Normal to Confirmed, Medium.

Not related to the 3d program. Running other 3d software at the same time will still cause delays. Currently there is no delay in recording video and playing video.

Hi.

By default (gizmos being hiden), everything works fine. I have tried to select faces on a cube very quickly, it worked fine. I could select them very quickly.
But after enabling Transform Gizmos (from the dropdown menu) and starting to select faces, I noticed a slight lag. And sometimes, I couldn't even see the "selection box".

Windows 10 64 bits on a SSD, nVidia GTX 1070 (latest drivers).

I'm not competent...
but the number faced with the problem is huge,
Yes, they all go to that branch and don't create a new bug.
is there any way to solve this bug before the release of 2.80?

Brecht Van Lommel (brecht) raised the priority of this task from Confirmed, Medium to Confirmed, High.Jun 17 2019, 12:46 PM

Note we are talking to NVIDIA about this, but no solution yet.

Just to be sure, can this still be reproduced with the latest daily build?

We are having trouble reproducing this, and it's still unclear why this happens for some users and not others.

Eugene (cgeugene) added a comment.EditedJun 24 2019, 7:11 PM

@Brecht Van Lommel (brecht)

Still the same

2.80 Beta Windows 64 bit June 24, 00:08:19 - 9c5d54bfaf48

win10 x64, 2080rtx, 430.86
win10 x64, 1050ti, 419.35

only Win + b3d - lag
Win + other run software + b3d - work

still there

maybe let's go back the replication stages

again here is how to replicate:

  1. kill all the tasks in a manager just default blender (this is very important even the app in the background can speed it up)
  2. the speedup does happen at some point so try to not hold MMB for too long just short moves to make it more pronounced,

for the test let's use the emulation and alt+LMB since its easier to release that button

here is how we test just rapid rotation around the cube
what you should feel is an annoying slowdown

  1. ok now let's compare it with and without other app running

I will use the NVIDIA overlay since it's faster than opening an app but opening unity or steam client will doo as well

rotate a viewport with it enabled and disabled


also, I can get the same stuff on other PC and Wacom companion but only on Windows I have 0 problems on Linux

I currently don't have an nvidia card so can't check, but can you see if switching this option to maximum performance (for just blender, second tab in that screenshot, not global) solves the issue when blender is running alone?

lag is still there

I tried to change other options like vertical synch and resetting to default but no luck

I currently don't have an nvidia card so can't check, but can you see if switching this option to maximum performance (for just blender, second tab in that screenshot, not global) solves the issue when blender is running alone?

It used to in 2.79 but no longer does in 2.8

System Information
Operating system: Windows-10-10.0.17763 64 Bits
Graphics card: GeForce GTX 970/PCIe/SSE2 NVIDIA Corporation 4.5.0 NVIDIA 430.86

Blender Version
Broken: version: 2.80 (sub 74), branch: master, commit date: 2019-07-03 22:34, hash: rBc252fe7a32ab

The problem is still present.

@Sergey Sharybin (sergey) and I spent quite some time debugging this, and we were finally able to reproduce it. We found the lagging to be worst when using the Move tool and dragging outside of the gizmo. Higher screen resolution also made a significant difference, like 2560x1440 instead 1920x1080. This was on a GTX 960 and Titan Xp, though the lag was more limited on the latter and perhaps just not noticeable except for the worst conditions.

We tried putting glFlush() in various places, and disabling lots of drawing code but this didn't help. What I found helped on the Titan Xp was a tweak to the GPU selection queries, specifically for cases where the gizmo event handling uses them. I don't know if this solves the whole issue, since it may just be a specific case as we also found some lagging without gizmos.

To tests this, please try the following in the latest build:

  • Press F3 to search for operators and run "Debug Menu"
  • Enter value 474 and press ok.
  • Test if the lagging is still there.

When a tool with a gizmo is enabled, it appears that every mousemove event causes a GPU select query. Disabling gizmo and overlay visibility does not stop that from happening, which might explain why we found lagging to still happen without gizmos.

If there are many such mouse move events, the 1ms sleep may added up to a significant amount. Or the CPU scheduler might switch to another thread or process and end up sleeping longer than 1ms.

With "Debug 474" no more lag. it work.

@Adrian Rutkowski (rrtk) can you check too?

Same here. I can confirm that debug code 474 solves the problem. Windows 10 1809 + GTX1080Ti

Great to hear it helped. I've now committed a slightly difference change, the latest builds should work without the debug value.

The new build works like a charm, awesome job